
{ Yep, here is the source code...

  You are allowed to modify and distribute your modified version freely,
  as long as
    a) you include the modified source code with it
    b) you somehow indicate in the version string below that this is not
       my original version
    c) you mail me a copy when it's done :)
       (my e-mail address is fdsoft@mail.gyor-ph.hu)

       [if you send me mail complaing about my coding style or about the
        lack of comments in some places, you will be ignored.]

  Oh, by the way.. You will need at least Turbo Pascal 7.0 to compile this
  shit.
}

program XCOM3_SaveGame_editor;

uses Crt, DOS;

const
  { Version number, please change it somehow if you modify this program.
    I would suggest the form of 'x.y - yourname'. }
  Version = '1.2';

  SaveGame_Directory = 'SAVEGAME\';
  Cityscape_Saves = 'SAVEGAME.';
  Tactical_Saves = 'TACTGAME.';

const
  {A complete UFOpaedia, not including the items which were removed from
   the final version.}
  UFOpaedia: array [1..279] of Byte =
    (1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1,
     1, 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1);

type
  TSaveGameInfo = record
    Description: String;
    FileName: String[Length(SaveGame_Directory) + 8 + 1 + 3];
    isTactical: Boolean;
    Date: String;
    Size: String;
  end;

  cString = array[0..255] of Char;

var
  f: file;
  games: array[0..9] of TSaveGameInfo;
  choices: array[1..400] of String[48];
  numvaluelist: Word;
  valuelist: array[1..500] of record
              Name: String[30];
              Value: Word;
            end;
  numchoices: Word;
  NullStr: cString;
  CurrentFile: String;
  sel: Byte;
  osel2, sel2, sel3: Word;

  b: Byte;
  w: Word;
  l: Longint;
  si: Shortint;
  s: String;

{ Simple text edit box for numeric only input, has Insert mode, cursor
  movement, knows Del/Backspace, etc. }
function InputNumericValue(default, min, max, maxlength: Longint): Longint;
var
  ch: Char;
  s1, s2: String;
  curpos: Byte;
  x, y: Byte;
  insertmode: Boolean;
  temp: Longint;
  errcode: Word;
begin
  TextBackground(Blue);
  TextColor(White);
  x := WhereX;
  for y := 1 to maxlength do Write(' ');
  y := WhereY;
  insertmode := True;
  GotoXY(x, y);
  Str(default, s1);
  if s1 = '0' then s1 := '';
  Write(s1);
  curpos := WhereX;
  asm
    mov ah, 1
    mov cx, 0607h
    int 10h
  end;
  repeat
    ch := ReadKey;
    if ch = #0 then
    begin
      ch := ReadKey;               { #9 }
      case ch of
        #75: if curpos > x then Dec(curpos);
        #77: if (curpos - x + 1) < Length(s1) + 1 then
               if (curpos - x + 1 < maxlength) then Inc(curpos);
        #71: curpos := x;
        #79:
          begin
            curpos := x + Length(s1);
            if (curpos - x + 1 > maxlength) then curpos := maxlength + x - 1;
          end;
        #82:
          begin
            insertmode := not insertmode;
            if insertmode then
            begin
              asm
                mov ah, 1
                mov cx, 0607h
                int 10h
              end;
            end
            else
            begin
              asm
                mov ah, 1
                mov cx, 0007h
                int 10h
              end;
            end;
          end;
        #83:
          begin
            if ((curpos - x + 1) < Length(s1) + 1) and (s1 <> '') then
            begin
              Delete(s1, curpos - x + 1, 1);
              GotoXY(x, y);
              Write(s1 + ' ');
              GotoXY(curpos, y);
            end;
          end;
      end;
      GotoXY(curpos, y);
    end
    else
    begin
      case ch of
        #8:
          begin
            if (s1 <> '') and (curpos > x) then
            begin
              Delete(s1, curpos - x, 1);
              Dec(curpos);
              GotoXY(x, y);
              Write(s1 + ' ');
              GotoXY(curpos, y);
            end;
          end;
        '0'..'9', '-':
          begin
            if ((ch <> '-') or ((min < 0) and (curpos = x))) and
               ((ch <> '0') or (curpos > x + 1) or
                ((curpos = x + 1) and (s1[1] <> '-'))) then
            begin
              s2 := s1;
              if (curpos - x + 1 = Length(s1) + 1) or (s1 = '') then
                s1 := s1 + ch
              else
              begin
                if insertmode then
                  Insert(ch, s1, curpos - x + 1)
                else
                  s1[curpos - x + 1] := ch;
              end;
              Val(s1, temp, errcode);
              if (Length(s1) <= maxlength) and (temp >= min) and
                 (temp <= max) and (errcode = 0) then
              begin
                if (curpos - x + 1 < maxlength) then Inc(curpos);
                GotoXY(x, y);
                Write(s1);
                GotoXY(curpos, y);
              end
              else
                s1 := s2;
            end;
          end;
      end;
    end;
  until (ch = #13) or (ch = #27);
  if ch = #27 then
  begin
    Str(default, s2);
    GotoXY(x, y);
    while Length(s2) < Length(s1) do s2 := s2 + ' ';
    Write(s2);
    Str(default, s1);
  end;
  if s1 = '' then begin s1 := '0'; GotoXY(x, y); Write(s1); end;
  Val(s1, temp, errcode);
  TextColor(Yellow);
  GotoXY(x, y);
  Str(temp, s1);
  while Length(s1) < maxlength do s1 := ' ' + s1;
  Write(s1);
  InputNumericValue := temp;
  asm
    mov ah, 1
    mov cx, 2000h
    int 10h
  end;
end;

{ Clears the screen and writes the header text }
procedure WriteHeader;
begin
  TextColor(LightGray);
{  ClrScr; }
  TextColor(Yellow);
  Writeln(' ' +
          '');
  TextColor(LightGray);
  Write(' X-COM: Apocalypse SAVEGAME editor v' + Version);
  GotoXY(79 - Length(CurrentFile), WhereY);
  Writeln(CurrentFile);
  TextColor(Yellow);
  Writeln(' ' +
          '');
  Writeln;
end;

{ Shows the quit message }
procedure Quit;
begin
  TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
  TextColor(LightGray);
  Writeln(' Thanks for using this little crap. :-)'#10);
  TextColor(Brown);
  Writeln(' CREDITS (see .txt for details)');
  Writeln(' ');
  Writeln(' fds0ft   fdsoft@mail.gyor-ph.hu');
  Writeln(' Larze    Larze@interact.se');
  Writeln(' '#10);
  TextColor(LightGray);
  Writeln(' Tell me what you think about it, drop me a mail at');
  Writeln('    fdsoft@mail.gyor-ph.hu');
  asm
    mov ah, 1
    mov cx, 0607h
    int 10h
  end;
end;

{ Show the error message in lightred, close the file if required, then
  exit to DOS with errorlevel 255 }
procedure ErrorMessage(msg: String; reqclose: Boolean);
begin
  TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
  if reqclose then Close(f);
  TextColor(LightRed);
  Writeln(' ' + msg);
  Halt($FF);
  asm
    mov ah, 1
    mov cx, 0607h
    int 10h
  end;
end;

{ Converts a Longint to a string, thousands seperated with commas }
function NumberToString(value: Longint): String;
var
  tmp_s1, tmp_s2: String;
  tmp_b1, tmp_b2: Byte;
begin
  tmp_s1 := '';
  Str(value, tmp_s2);
  tmp_b2 := 0;
  for tmp_b1 := Length(tmp_s2) downto 1 do
  begin
    tmp_s1 := tmp_s2[tmp_b1] + tmp_s1;
    Inc(tmp_b2);
    if (tmp_b2 = 3) and (tmp_b1 > 1) then
    begin
      tmp_s1 := ',' + tmp_s1;
      tmp_b2 := 0;
    end;
  end;
  NumberToString := tmp_s1;
end;

{ Converts a C-style zero terminated string to a Pascal-type string }
function NullTerminatedToPasString(cs: cString): String;
var
  tmp_s1: String;
  tmp_b1: Byte;
begin
  tmp_b1 := 0;
  while cs[tmp_b1] <> #0 do
    Inc(tmp_b1);
  Move(cs, tmp_s1[1], tmp_b1);
  tmp_s1[0] := Chr(tmp_b1);
  NullTerminatedToPasString := tmp_s1;
end;

{ Loads the basic information form the SAVEGAME directory to the games
  record }
procedure LoadSaveGameDirectory;
begin
  { Make sure there will be no memory garbage in the game info record }
  FillChar(games, SizeOf(games), 0);

  for b := 0 to 9 do
  begin
    Str(b, s);
    if Length(s) = 1 then s := '0' + s;
    Assign(f, SaveGame_Directory + Cityscape_Saves + s);
    {$I-}
    Reset(f, 1);
    {$I+}
    if IOResult = 0 then
    begin
      with games[b] do
      begin
        FileName := SaveGame_Directory + Cityscape_Saves + s;
        isTactical := False;
        Size := NumberToString(FileSize(f));
        FillChar(NullStr, SizeOf(NullStr), 0);
        BlockRead(f, NullStr, 40);
        Date := NullTerminatedToPasString(NullStr);
        FillChar(NullStr, SizeOf(NullStr), 0);
        BlockRead(f, NullStr, 40);
        Description := NullTerminatedToPasString(NullStr);
      end;
      Close(f);
    end
    else
    begin
      Assign(f, SaveGame_Directory + Tactical_Saves + s);
      {$I-}
      Reset(f, 1);
      {$I+}
      if IOResult = 0 then
      begin
        with games[b] do
        begin
          FileName := SaveGame_Directory + Tactical_Saves + s;
          isTactical := True;
          Size := NumberToString(FileSize(f));
          FillChar(NullStr, SizeOf(NullStr), 0);
          BlockRead(f, NullStr, 40);
          Date := NullTerminatedToPasString(NullStr);
          FillChar(NullStr, SizeOf(NullStr), 0);
          BlockRead(f, NullStr, 40);
          Description := NullTerminatedToPasString(NullStr);
        end;
        Close(f);
      end;
    end;
  end;
end;

{ Writes a line of the main menu (savegame selector) }
procedure WriteMainMenuLine(which: Byte; selected: Boolean; ontop: Boolean);
begin
  if ontop then GotoXY(1, 5) else GotoXY(1, 5 + 2 * which);
  if not selected then TextBackground(Black) else TextBackground(Blue);
  with games[which] do
  begin
    s := Description;
    s := ' ' + s + '' + Size + ' bytes';
    while Length(s) < 79 do
      s := Copy(s, 1, Pos('', s)) + ' ' +
    Copy(s, Pos('', s) + 1, Length(s) - Pos('', s));
    s[Pos('', s)] := ' ';
    if not selected then TextColor(LightGray) else TextColor(White);
    Write(s); ClrEol; Writeln;
    if not selected then TextColor(DarkGray) else TextColor(LightGray);
    Write('   ' + Date); ClrEol; Writeln;
  end;
end;

{ Deselects the old main menu selection and highlights the new one }
procedure ChangeMainMenuSelection(_from, _to: Byte);
begin
  WriteMainMenuLine(_from, False, False);
  WriteMainMenuLine(_to, True, False);
end;

{ The whole main menu code, allows the user to select which saved game
  he/she wants to edit }
function MainMenu: Shortint;
var
  oldsel: Byte;
  ch: Char;
begin
  for b := 0 to 9 do
    WriteMainMenuLine(b, b = sel, False);

  repeat
    ch := ReadKey;
    oldsel := sel;
    case ch of
      '0'..'9': sel := Ord(ch) - Ord('0');
    end;
    if ch = #0 then
    begin
      ch := ReadKey;
      case ch of
        #80:     {down arrow}
          if sel < 9 then Inc(sel);
        #72:     {up arrow}
          if sel > 0 then Dec(sel);
        #81, #79: {page down, end}
          sel := 9;
        #73, #71: {page up, home}
          sel := 0;
      end;
    end;
    if oldsel <> sel then
      ChangeMainMenuSelection(oldsel, sel);
  until (ch = #13) or (ch = #27);

  if ch = #13 then    { user pressed Enter }
    MainMenu := sel
  else
    MainMenu := -1;   { user pressed Esc }
end;

{ A simple menu selector, good even for long lists. The number of the choices
  is in the 'numchoices' variable, the choices are in 'choices'.
  Returns -1 if the user pressed Esc, otherwise the return value is zero,
  and 'sel2' contains the index of the selected item. }
function SelectFromChoices(AllowAsterisk: Boolean): Shortint;
var
  MenuTop: Word;
  UpperItem: Word;
  oldsel2: Word;
  ch: Char;

  procedure ShowChoices;
  begin
    GotoXY(1, MenuTop);
    for w := UpperItem to NumChoices do
    begin
      if sel2 = w then
      begin
        TextColor(Yellow); TextBackground(Blue);
      end
      else
      begin
        TextColor(White); TextBackground(Black);
      end;
      Write(' ' + Choices[w]); ClrEol;
      if WhereY = 25 then
        Break
      else
        Writeln;
    end;
  end;

begin
  MenuTop := WhereY;
  UpperItem := 1;
  while sel2 > UpperItem + 25 - MenuTop do Inc(UpperItem);
  ShowChoices;
  repeat
    ch := ReadKey;
    oldsel2 := sel2;
    if ch = #0 then
    begin
      ch := ReadKey;
      case ch of
        #80:     {down arrow}
          if sel2 < numchoices then Inc(sel2);
        #72:     {up arrow}
          if sel2 > 1 then Dec(sel2);
        #81:     {page down}
          if sel2 < numchoices then
          begin
            Inc(sel2, 25 - MenuTop);
            if sel2 > numchoices then sel2 := numchoices;
          end;
        #79:     {end}
          sel2 := numchoices;
        #73:
          if sel2 > 1 then
          begin
            if sel2 > 25 - MenuTop + 1 then
              Dec(sel2, 25 - MenuTop)
            else
              sel2 := 1;
          end;
        #71:     {home}
          sel2 := 1;
      end;
    end;
    if oldsel2 <> sel2 then
    begin
      GotoXY(1, MenuTop + oldsel2 - UpperItem);
      TextColor(White); TextBackground(Black);
      Write(' ' + Choices[oldsel2]); ClrEol;
      oldsel2 := UpperItem;
      if sel2 < UpperItem then UpperItem := sel2;
      while sel2 > UpperItem + 25 - MenuTop do Inc(UpperItem);
      if oldsel2 <> UpperItem then
        ShowChoices
      else
      begin
        GotoXY(1, MenuTop + sel2 - UpperItem);
        TextColor(Yellow); TextBackground(Blue);
        Write(' ' + Choices[sel2]); ClrEol;
      end;

    end;
  until (ch = #13) or (ch = #27) or
        (AllowAsterisk and ((ch = '*') or (ch = '-') or (ch = '+')));

  if ch = #13 then    { user pressed Enter }
    SelectFromChoices := 0
  else
    SelectFromChoices := -1;   { user pressed Esc }
  if ch = '*' then SelectFromChoices := 2;
  if ch = '-' then SelectFromChoices := 3;
  if ch = '+' then SelectFromChoices := 4;
end;

{ A special version of SelectFromChoices, for editing a list of values }
function EditList(maxlength: Byte; isWord: Boolean;
                  PlusMinus, isTact: Boolean): Shortint;
var
  MenuTop: Word;
  UpperItem: Word;
  oldsel3: Word;
  ch: Char;
  maxx: Word;
  s: String;

  procedure Showvaluelist;
  begin
    GotoXY(1, MenuTop);
    for w := UpperItem to Numvaluelist do
    begin
      TextColor(LightCyan);
      TextBackground(Black);
      if valuelist[w].name[1] <> '#' then
        Write(' ' + valuelist[w].name)
      else
      begin
        TextColor(Cyan);
        Write('   ' + Copy(valuelist[w].name, 2, Length(valuelist[w].name) - 1));
      end;
      ClrEol;
      GotoXY(maxx, WhereY);
      if (isTact) and (w > 2) then Write('  ');
      if sel3 = w then
      begin
        TextColor(Yellow); TextBackground(Blue);
      end
      else
      begin
        TextColor(LightGreen); TextBackground(Black);
      end;
      Str(valuelist[w].value, s);
      if (isTact) and (w <= 2) then maxlength := 6;
      if (isTact) and (w > 2) then maxlength := 4;
      while Length(s) < maxlength do s := ' ' + s;
      Write(s);
      TextBackground(Black);
      if WhereY = 25 then
        Break
      else
        Writeln;
    end;
  end;

begin
  MenuTop := WhereY;
  maxx := 0;
  for oldsel3 := 1 to numvaluelist do
  begin
    if Length(valuelist[oldsel3].name) > maxx then
      maxx := Length(valuelist[oldsel3].name);
  end;
  maxx := maxx + 4;
  UpperItem := 1;
  while sel3 > UpperItem + 25 - MenuTop do Inc(UpperItem);
  Showvaluelist;
  repeat
    ch := ReadKey;
    oldsel3 := sel3;
    if ((ch = '+') or (ch = '-')) then
    begin
      if (isWord) or ((isTact) and (sel3 <= 2)) then
        oldsel3 := 65535 else oldsel3 := 255;
      if (valuelist[sel3].value > 0) and (ch = '-') then
        Dec(valuelist[sel3].value);
      if (valuelist[sel3].value < oldsel3) and (ch = '+') then
        Inc(valuelist[sel3].value);
      oldsel3 := sel3 + 1;
    end;

    if ch = #0 then
    begin
      ch := ReadKey;
      case ch of
        #80:     {down arrow}
          if sel3 < numvaluelist then Inc(sel3);
        #72:     {up arrow}
          if sel3 > 1 then Dec(sel3);
        #81:     {page down}
          if sel3 < numvaluelist then
          begin
            Inc(sel3, 25 - MenuTop);
            if sel3 > numvaluelist then sel3 := numvaluelist;
          end;
        #79:     {end}
          sel3 := numvaluelist;
        #73:
          if sel3 > 1 then
          begin
            if sel3 > 25 - MenuTop + 1 then
              Dec(sel3, 25 - MenuTop)
            else
              sel3 := 1;
          end;
        #71:     {home}
          sel3 := 1;
      end;
    end
    else
    if ch = #13 then
    begin
      GotoXY(maxx, MenuTop + sel3 - UpperItem);
      if (isTact) and (sel3 > 2) then Write('  ');
      if (isWord) or ((isTact) and (sel3 <= 2)) then
        valuelist[sel3].value :=
          InputNumericValue(valuelist[sel3].value, 0, 65535, 6)
      else
        valuelist[sel3].value :=
          InputNumericValue(valuelist[sel3].value, 0, 255, 4);
    end;
    if oldsel3 <> sel3 then
    begin
      oldsel3 := UpperItem;
      if sel3 < UpperItem then UpperItem := sel3;
      while sel3 > UpperItem + 25 - MenuTop do Inc(UpperItem);
      Showvaluelist;
    end;
  until (ch = #27) or
    (PlusMinus and (ch = '[') or (ch = ']'));
  if ch = #27 then EditList := 0;
  if ch = '[' then EditList := 3;
  if ch = ']' then EditList := 4;
end;

{ Edits soldier/biochemist/engineer/quantum physicist data }
procedure EditPeople;
var
  shi, sh2: Shortint;
  b1: Byte;
  w1: Word;
const
  aliens: array[1..13] of String[30] =
  ('Anthropod ', 'Skeletoid ', 'Popper ', 'Micronoid Aggregate ',
   'Brainsucker ', 'Psimorph ', 'Megaspawn ', 'Spitter ',
   'Multiworm ', 'Hyperworm ', 'Alien Egg ', 'Queenspawn ',
   'Chrysalis ');
  tactical_idx: array[1..18] of Byte =
   (94, 92, 136, 109, 111, 110, 130, 131, 132, 108, 99, 98, 107, 106, 103,
    102, 84, 82);
  tactical_god: array[1..18] of Byte =
   (255, 255, 0, 25, 255, 255, 255, 255, 255, 100, 200, 200, 255, 255,
    255, 255, 255, 255);
  tactical_desc: array[1..18] of String[21] =
   ('Health (current)',
    'Health (max)',
    'Accuracy',
    'Bravery',
    'Psi-energy (current)',
    'Psi-energy (max)',
    'Psi-attack',
    'Psi-defense (current)',
    'Psi-defense (max)',
    'Morale',
    'Stamina (current)',
    'Stamina (max)',
    'Strength (current)',
    'Strength (max)',
    'Reactions (current)',
    'Reactions (max)',
    'Time Units (current)',
    'Time Units (max)');
  ranks: array[0..6] of String[13] =
    ('Rookie', 'Squaddie', 'Squad Leader', 'Sergeant', 'Captain',
     'Colonel', 'Commander');

  procedure KillAlien;
  begin
          Seek(f, l + 58);
          b := 250;
          BlockWrite(f, b, 1);

          Seek(f, l + 76); {critical wounds}
          b := 3;
          BlockWrite(f, b, 1);  {legs}
          BlockWrite(f, b, 1);  {torso}
          BlockWrite(f, b, 1);  {right arm}
          BlockWrite(f, b, 1);  {left arm}
          BlockWrite(f, b, 1);  {head}

{ stun
          Seek(f, l + 122);
          b := 250;
          BlockWrite(f, b, 1);
          Seek(f, l + 640);
          b := 1;
          BlockWrite(f, b, 1);
          b := 6;
          Seek(f, l + 200);
          BlockWrite(f, b, 1);
          Seek(f, l + 642);
          BlockWrite(f, b, 1);
          BlockWrite(f, b, 1);
}
{+122 41
+200 06
+640 01
+642, +643 06}

          for b := 4 to 10 do
          begin
            Seek(f, l + tactical_idx[b]);
            b1 := 0;
            BlockWrite(f, b1, 1);
          end;
          for b := 11 to 16 do
          begin
            Seek(f, l + tactical_idx[b]);
            BlockRead(f, b1, 1);
            if b1 > 0 then
            begin
              b1 := 1;
              BlockWrite(f, b1, 1);
            end;
          end;
          Seek(f, l + tactical_idx[17]);
          b1 := 0;
          BlockWrite(f, b1, 1);
          Seek(f, l + tactical_idx[1]);
          BlockRead(f, w1, 2);
          Seek(f, l + tactical_idx[1]);
          if w1 > 0 then
          begin
            w1 := 1;
            BlockWrite(f, w1, 2);
          end;
  end;

begin
  FileMode := 2;
  Assign(f, games[sel].FileName);
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Cannot open file ' + games[sel].FileName + '.', False);

  if games[sel].isTactical then l := $21108 else l := $20D6A;
  numchoices := 0;
  repeat
    Seek(f, l);
    BlockRead(f, NullStr, 90);
    if NullStr[0] <> #0 then
    begin
      Inc(numchoices);
      choices[numchoices] := NullTerminatedToPasString(NullStr);
    end;
    if games[sel].isTactical then Inc(l, 1180) else Inc(l, 206);
  until NullStr[0] = #0;
  if numchoices > 0 then
  begin
    sel2 := 1;
    repeat
      TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
      TextColor(LightCyan);
      if games[sel].isTactical then
      begin
        TextColor(LightGreen);
        Write(' Enter ');
        TextColor(LightCyan);
        Write('edit unit ');
        TextColor(LightGreen);
        Write(' * ');
        TextColor(LightCyan);
        Write('try to kill every alien ');
        TextColor(LightGreen);
        Write(' - ');
        TextColor(LightCyan);
        Write('kill unit ');
        TextColor(LightGreen);
        Write(' + ');
        TextColor(LightCyan);
        Writeln('pump up unit'#10);
      end
      else
      begin
        Write(' Select someone to edit manually, or press ');
        TextColor(LightGreen);
        Write('*');
        TextColor(LightCyan);
        Writeln(' to pump up everyone to maximum.'#10);
      end;
      Close(f);
      shi := SelectFromChoices(True);
      Reset(f, 1);
      if shi = 3 then
      begin
        if games[sel].isTactical then
        begin
          l := $21108 + (sel2 - 1) * 1180;
          KillAlien;
        end;
      end;
      if shi = 4 then
      begin
        if games[sel].isTactical then
        begin
          l := $21108 + (sel2 - 1) * 1180;

          Seek(f, l + 76); {critical wounds}
          b := 0;
          BlockWrite(f, b, 1);  {legs}
          BlockWrite(f, b, 1);  {torso}
          BlockWrite(f, b, 1);  {right arm}
          BlockWrite(f, b, 1);  {left arm}
          BlockWrite(f, b, 1);  {head}

          Seek(f, l + 58);
          b := 0;
          BlockWrite(f, b, 1);

          for b := 1 to 18 do
          begin
            Seek(f, l + tactical_idx[b]);
            if b <= 2 then
            begin
              w1 := 255;
              BlockWrite(f, w1, 2);
            end
            else
            begin
              b1 := tactical_god[b];
              BlockWrite(f, b1, 1);
            end;
          end;
        end;
      end;
      if shi = 2 then
      begin
        if games[sel].isTactical then
        begin
          l := $21108;
          repeat
            Seek(f, l);
            BlockRead(f, NullStr, 90);
            if NullStr[0] <> #0 then
            begin
              s := NullTerminatedToPasString(NullStr);
              for b := 1 to 13 do
                if aliens[b] = s then begin s := '-'; Break end;
              if s = '-' then
                KillAlien;
            end;
            Inc(l, 1180);
          until NullStr[0] = #0;
        end
        else
        begin
          l := $20D6A;
          repeat
            Seek(f, l);
            BlockRead(f, NullStr, 90);
            if NullStr[0] <> #0 then
            begin
              b := 240;
              Seek(f, l + 58);
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              Seek(f, l + 70);
              b := 0;
              BlockWrite(f, b, 1);
              Seek(f, l + 62);
              b := 200;
              BlockWrite(f, b, 1);
              b := 240;
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              b := 24;
              BlockWrite(f, b, 1);
              b := 240;
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              Seek(f, l + 73);
              b := 255;
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
              BlockWrite(f, b, 1);
            end;
            Inc(l, 206);
          until NullStr[0] = #0;
        end;
      end;
      if shi = 0 then
      begin
        TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;

        if games[sel].isTactical then
        begin
          l := $21108 + (sel2 - 1) * 1180;

          for b := 1 to 18 do
            valuelist[b].name := tactical_desc[b];

          for b := 1 to 18 do
          begin
            Seek(f, l + tactical_idx[b]);
            if b <= 2 then
              BlockRead(f, w1, 2)
            else
            begin
              BlockRead(f, b1, 1);
              if b = 3 then b1 := 100 - b1;
              w1 := b1;
              if b = 4 then w1 := b1 * 10;
              if (b = 11) or (b = 12) then w1 := w1 div 2;
            end;
            valuelist[b].value := w1;
          end;
          numvaluelist := 18;
          sel3 := 1;

          repeat
            GotoXY(1, 1);
            TextBackground(Black); TextColor(LightGray); WriteHeader;
            Seek(f, l + 41);
            BlockRead(f, b, 1);
            Seek(f, l);
            BlockRead(f, NullStr, 90);
            TextColor(White);
            Write(' ' + NullTerminatedToPasString(NullStr));
            GotoXY(30, WhereY);
            TextColor(LightCyan);
            Write(' Rank: ');
            TextColor(LightGreen);
            Write(ranks[b]);
            TextColor(LightGray);
            Write(' (press [ or ] to change)'); ClrEol;
            GotoXY(1, WhereY + 2);

            Close(f);
            sh2 := EditList(4, False, True, True);
            FileMode := 2;
            Reset(f, 1);
            Seek(f, l + 41);
            BlockRead(f, b, 1);
            if (sh2 = 3) and (b > 0) then Dec(b);
            if (sh2 = 4) and (b < 6) then Inc(b);
            Seek(f, l + 41);
            BlockWrite(f, b, 1);
          until sh2 = 0;
          for b := 1 to 18 do
          begin
            Seek(f, l + tactical_idx[b]);
            w1 := valuelist[b].value;
            if (b = 3) then
            begin
              if (w1 <= 100) then w1 := 100 - w1 else w1 := 0;
            end;
            if b = 4 then w1 := w1 div 10;
            if b <= 2 then
              BlockWrite(f, w1, 2)
            else
            begin
              if (b = 11) or (b = 12) then
              begin
                w1 := w1 * 2;
                if w1 > 255 then w1 := 255;
              end;
              b1 := w1;
              BlockWrite(f, b1, 1);
            end;
          end;
        end
        else
        begin
          l := $20D6A + (sel2 - 1) * 206;

          { +60 / +59 }
          Seek(f, l + 60);
          BlockRead(f, b, 1);
          valuelist[1].value := b;
          Seek(f, l + 59);
          BlockRead(f, b, 1);
          valuelist[2].value := b;
          { +70 }
          Seek(f, l + 70);
          BlockRead(f, b, 1);
          valuelist[3].value := 100 - b;
          { +63 }
          Seek(f, l + 63);
          BlockRead(f, b, 1);
          valuelist[4].value := b;
          { +58 }
          Seek(f, l + 58);
          BlockRead(f, b, 1);
          valuelist[5].value := b;
          { +62 }
          Seek(f, l + 62);
          BlockRead(f, b, 1);
          valuelist[6].value := b div 2;
  {        Write(' Bravery     ');  { +51, +65 }
          Seek(f, l + 65);
          BlockRead(f, b, 1);
          valuelist[7].value := b * 10;
  {        Write(' Strength    ');  { +64 }
          Seek(f, l + 64);
          BlockRead(f, b, 1);
          valuelist[8].value := b;
  {        Write(' Psi-energy  ');  { +53, +66 }
          Seek(f, l + 66);
          BlockRead(f, b, 1);
          valuelist[9].value := b;
  {        Write(' Psi-attack  ');  { }
          Seek(f, l + 67);
          BlockRead(f, b, 1);
          valuelist[10].value := b;
  {        Write(' Psi-defense ');  { }
          Seek(f, l + 68);
          BlockRead(f, b, 1);
          valuelist[11].value := b;
  {        Write(#10' Biochemistry Skill    ');  { +73 }
          Seek(f, l + 73);
          BlockRead(f, b, 1);
          valuelist[12].value := b;
  {        Write(' Quantum Physics Skill ');  { +74 }
          Seek(f, l + 74);
          BlockRead(f, b, 1);
          valuelist[13].value := b;
  {        Write(' Engineering Skill        ');  { }
          Seek(f, l + 75);
          BlockRead(f, b, 1);
          valuelist[14].value := b;

          Seek(f, l + 181);
          BlockRead(f, b, 1);
          valuelist[15].value := b;

          TextColor(LightCyan);
          Writeln(' Health');
          valuelist[1].name := '#current';
          valuelist[2].name := '#max';
          valuelist[3].name := 'Accuracy';
          valuelist[4].name := 'Reactions';
          valuelist[5].name := 'Speed';
          valuelist[6].name := 'Stamina';
          valuelist[7].name := 'Bravery';
          valuelist[8].name := 'Strength';
          valuelist[9].name := 'Psi-energy';
          valuelist[10].name := 'Psi-attack';
          valuelist[11].name := 'Psi-defense';
          valuelist[12].name := 'Biochemistry skill';
          valuelist[13].name := 'Quantum Physics skill';
          valuelist[14].name := 'Engineering skill';

          valuelist[15].name := 'Face';
          numvaluelist := 15;
          sel3 := 1;

          repeat
            GotoXY(1, 1);
            TextBackground(Black); TextColor(LightGray); WriteHeader;
            Seek(f, l + 34);
            BlockRead(f, b, 1);
            Seek(f, l);
            BlockRead(f, NullStr, 90);
            TextColor(White);
            Writeln(' ' + NullTerminatedToPasString(NullStr) + #10);
            TextColor(LightCyan);
            Write(' Rank                    ');
            TextColor(LightGreen);
            Write(ranks[b]);
            TextColor(LightGray);
            Write(' (press [ or ] to change)'); ClrEol;
            Writeln;
            Close(f);
            sh2 := EditList(4, False, True, False);
            FileMode := 2;
            Reset(f, 1);
            Seek(f, l + 34);
            BlockRead(f, b, 1);
            if (sh2 = 3) and (b > 0) then Dec(b);
            if (sh2 = 4) and (b < 6) then Inc(b);
            Seek(f, l + 34);
            BlockWrite(f, b, 1);
          until sh2 = 0;

          Seek(f, l + 60);
          b := valuelist[1].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 59);
          b := valuelist[2].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 70);
          if valuelist[3].value > 100 then valuelist[3].value := 100;
          b := 100 - valuelist[3].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 63);
          b := valuelist[4].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 58);
          b := valuelist[5].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 62);
          b := valuelist[6].value;
          if b > 255 div 2 then b := 255 div 2;
          b := b * 2;
          BlockWrite(f, b, 1);
          Seek(f, l + 65);
          b := valuelist[7].value div 10;
          BlockWrite(f, b, 1);
          Seek(f, l + 64);
          b := valuelist[8].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 66);
          b := valuelist[9].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 67);
          b := valuelist[10].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 68);
          b := valuelist[11].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 73);
          b := valuelist[12].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 74);
          b := valuelist[13].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 75);
          b := valuelist[14].value;
          BlockWrite(f, b, 1);
          Seek(f, l + 181);
          b := valuelist[15].value;
          BlockWrite(f, b, 1);
        end;
      end;
    until shi = -1;
  end;
  Close(f);
end;

{ Base layout viewer / editor }
procedure BaseLayout(basenum: Word);
var
  base: array[1..8, 1..8] of Byte;
  sx, sy, x, y: Byte;
  wx, wy, ps: Byte;
  s1, s2: String;
  ch: Char;
  zeroout: Boolean;

{ Translates X-COM building type code to the vertical position on the screen }
function TypeToY(typ: Byte): Byte;
var
  zy: Byte;
  tp: Byte;
begin
  tp := typ;
  if tp = 201 then tp := base[sy, sx - 1] else
  if tp = 203 then tp := base[sy - 1, sx] else
  if tp = 202 then tp := base[sy - 1, sx - 1];
  case tp of
    0: zy := 2;
    1..15: zy := 3;
    16..18: zy := tp - 12;
    20..30: zy := tp - 13;
    32..33: zy := tp - 14;
    else zy := 1;
  end;
  TypeToY := zy;
end;

{ Translates vertical position to X-COM building type code }
function YToType(y: Byte): Byte;
var
  zy: Byte;
  tp: Byte;
begin
  tp := y;
  case tp of
    2: zy := 0;
    3: zy := 3;
    4..6: zy := tp + 12;
    7..17: zy := tp + 13;
    18..19: zy := tp + 14;
  end;
  YToType := zy;
end;

{ Recalculates every corridor tile to make sure the correct one is used }
procedure FixCorridors;
var
  x, y: Byte;
  k: Byte;
  basec: array[0..9, 0..9] of Byte;
begin
  FillChar(basec, SizeOf(basec), 0);
  for y := 1 to 8 do
    for x := 1 to 8 do
      basec[y, x] := base[y, x];
  for y := 1 to 8 do
    for x := 1 to 8 do
    begin
      k := basec[y, x];
      case basec[y, x] of
        1..15:
        begin
          if (x = 1) and (y = 1) then k := 6
          else
          if (x = 8) and (y = 8) then k := 9
          else
          if (x = 1) and (y = 8) then k := 3
          else
          if (x = 8) and (y = 1) then k := 12
          else
          if (basec[y - 1, x] > 0) and (basec[y + 1, x] > 0) and
{}          (basec[y, x - 1] > 0) and (basec[y, x + 1] > 0) then k := 15
          else
          if (basec[y - 1, x] > 0) and (basec[y + 1, x] > 0) and
{}          (basec[y, x - 1] > 0) then k := 13
          else
          if (basec[y - 1, x] > 0) and (basec[y + 1, x] > 0) and
{}          (basec[y, x + 1] > 0) then k := 7
          else
          if (basec[y, x - 1] > 0) and (basec[y, x + 1] > 0) and
{}          (basec[y - 1, x] > 0) then k := 11
          else
          if (basec[y, x - 1] > 0) and (basec[y, x + 1] > 0) and
{}          (basec[y + 1, x] > 0) then k := 14
          else
{}       if (basec[y, x - 1] > 0) and (basec[y + 1, x] > 0) then k := 12
          else
{}       if (basec[y, x + 1] > 0) and (basec[y + 1, x] > 0) then k := 6
          else
{}       if (basec[y, x - 1] > 0) and (basec[y - 1, x] > 0) then k := 9
          else
{}       if (basec[y, x + 1] > 0) and (basec[y - 1, x] > 0) then k := 3
          else
{}       if (basec[y, x - 1] > 0) and (basec[y, x + 1] > 0) then k := 10
          else
          if (basec[y - 1, x] > 0) and (basec[y + 1, x] > 0) then k := 5
          else
          if (basec[y, x + 1] > 0) then k := 2
          else
          if (basec[y, x - 1] > 0) then k := 8
          else
          if (basec[y - 1, x] > 0) then k := 1
          else
          if (basec[y + 1, x] > 0) then k := 4
          else
          k := 15;
          basec[y, x] := k;
        end;
      end;
    end;
  for y := 1 to 8 do
    for x := 1 to 8 do
      base[y, x] := basec[y, x];
end;

{ "Paints" the base.. heh.. actually ASCII art rule, so don't expect much ;) }
procedure PaintBase;
var
  x, y: Byte;
begin
  TextBackground(Black);
  TextColor(Yellow);
  GotoXY(48, TypeToY(base[sy, sx]));
  Write('');
  GotoXY(53, TypeToY(base[sy, sx]));
  Write('');

  TextColor(Brown);
  Str(sx, s1);
  Str(sy, s2);
  s1 := 'Pos: ' + s1 + ', ' + s2;
  GotoXY(80 - Length(s1), 1);
  Write(s1);
  TextColor(DarkGray);
  GotoXY(80 - 3, 2);
  Write(base[sy, sx]:3);

  GotoXY(1, 1);
  for y := 1 to 8 do
  begin
    for x := 1 to 8 do
    begin
      if ((sx = x) and (sy = y)) then
      begin
        TextBackground(Magenta);
        TextColor(Yellow);
      end
      else
      begin
        TextBackground(Black);
        TextColor(LightGray);
      end;

      if ((sx = x - 1) and (sy = y) and (base[y, x] = 201)) or
         ((sx = x) and (sy = y - 1) and (base[y, x] = 203)) or
         ((sx = x - 1) and (sy = y - 1) and (base[y, x] = 202)) or
         ((base[sy, sx] = 201) and
         (((sx = x + 1) and (sy = y)) or
         ((sx = x + 1) and (sy = y - 1)) or
         ((sx = x) and (sy = y - 1)))) or
         ((base[sy, sx] = 203) and
         (((sx = x) and (sy = y + 1)) or
         ((sx = x - 1) and (sy = y)) or
         ((sx = x - 1) and (sy = y + 1)))) or
         ((base[sy, sx] = 202) and
         (((sx = x) and (sy = y + 1)) or
         ((sx = x + 1) and (sy = y)) or
         ((sx = x + 1) and (sy = y + 1)))) then
         begin
           TextBackground(Blue);
           TextColor(Yellow);
         end;

      wx := WhereX;
      wy := WhereY;
      case base[y, x] of
         0: Write('   ');
         1, 3, 5, 7, 9, 11, 13, 15: Write('    ');
         2, 4, 6, 8, 10, 12, 14: Write('     ');
        19, 20, 26, 17, 30, 22, 32, 16, 18, 21, 28, 23, 24, 201:
          begin
            if (base[y, x]) = 201 then Write('') else Write('');
            if (y > 1) and (base[y - 1, x] > 0) then
              Write('')
            else
              Write('');
            Write('ͻ');
          end;
        203: Write('    ');
        202: Write('    ');
        25, 27, 29, 31, 33:
          begin
            Write('');
            if (y > 1) and (base[y - 1, x] > 0) then
              Write('')
            else
              Write('');
            Write('');
          end;
        else Write('?????');
      end;
      GotoXY(wx, wy + 1);
      case base[y, x] of
         0: Write('   ');
         1, 4, 5: Write('    ');
         2: Write('  ');
         3: Write('  ');
         6: Write('  ');
         7: Write('  ');
         8: Write('  ');
         9: Write('ͼ  ');
        10: Write('');
        11: Write('');
        12: Write('ͻ  ');
        13: Write('͹  ');
        14: Write('');
        15: Write('');
        19, 20, 26, 17, 30, 22, 32, 16, 18, 21, 28, 23, 24, 201, 202, 203:
          begin
            if ((base[y, x]) > 202) or ((base[y, x]) < 201) then
            begin
              if (x > 1) and (base[y, x - 1] > 0) then
                Write('')
              else
                Write('');
            end
            else
              Write(' ');

            case base[y, x] of
              19: Write('cel');
              20: Write('med');
              26: Write('bio');
              17: Write('liv');
              30: Write('ali');
              22: Write('psi');
              32: Write('wrk');
              16: Write('lft');
              18: Write('str');
              21: Write('trn');
              28: Write('qua');
              23: Write('sec');
              24: Write('asc');
              201, 202, 203: Write('   ');
            end;

            if ((base[y, x]) <> 203) then
            begin
              if (x < 8) and (base[y, x + 1] > 0) then
                Write('')
              else
                Write('');
            end
            else
            Write(' ');
          end;
        25, 27, 29, 31, 33:
          begin
            if (x > 1) and (base[y, x - 1] > 0) then
              Write('')
            else
              Write('');
            case base[y, x] of
              25: Write('rep ');
              27: Write('abio');
              29: Write('aqua');
              31: Write('aali');
              33: Write('awrk');
            end;
          end;
        else Write('?????');
      end;
      GotoXY(wx, wy + 2);
      case base[y, x] of
         0: Write('   ');
         1, 2, 3, 8, 9, 10, 11: Write('     ');
         4, 5, 6, 7, 12, 13, 14, 15: Write('    ');
        19, 20, 26, 17, 30, 22, 32, 16, 18, 21, 28, 23, 24:
          begin
            Write('');
            if (y < 8) and (base[y + 1, x] > 0) then
              Write('')
            else
              Write('');
            Write('ͼ');
          end;
        201: Write('    ');
        202, 203:
          begin
            if base[y, x] = 202 then Write('') else Write('');
            Write('');
            if (y < 8) and (base[y + 1, x] > 0) then
              Write('')
            else
              Write('');
            Write('');
            if base[y, x] = 203 then Write('') else Write('');
          end;
        25, 27, 29, 31, 33: Write('    ');
        else Write('?????');
      end;
      GotoXY(WhereX, wy);
    end;
    GotoXY(1, WhereY + 3);
  end;
end;

{ procedure BaseLayout(basenum: Word); }
begin
  TextBackground(Black); TextColor(LightGray); ClrScr;
  TextColor(LightGray);
  Assign(f, games[sel].FileName);
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Cannot open file ' + games[sel].FileName + '.', False);
  Seek(f, $1DF6C + (basenum - 1) * 702 + 20);
  BlockRead(f, base, 8 * 8);
  FixCorridors;
  Close(f);
  sx := 1; sy := 1;
  zeroout := False;

  TextColor(Green);
  GotoXY(50, 2);
  Write(' ');
  TextColor(LightCyan);
  Write(' Earth');
  GotoXY(50, 3);
  TextColor(Green);
  Write('  ');
  TextColor(LightCyan);
  Write(' Corridor');
  GotoXY(50, 4);
  TextColor(Green);
  Write('lft');
  TextColor(LightCyan);
  Write(' Access Lift');
  GotoXY(50, 5);
  TextColor(Green);
  Write('liv');
  TextColor(LightCyan);
  Write(' Living Quarters');
  GotoXY(50, 6);
  TextColor(Green);
  Write('str');
  TextColor(LightCyan);
  Write(' Stores');
  GotoXY(50, 7);
  TextColor(Green);
  Write('med');
  TextColor(LightCyan);
  Write(' Medical Bay');
  GotoXY(50, 8);
  TextColor(Green);
  Write('trn');
  TextColor(LightCyan);
  Write(' Training Area');
  GotoXY(50, 9);
  TextColor(Green);
  Write('psi');
  TextColor(LightCyan);
  Write(' Psi-gym');
  GotoXY(50, 10);
  TextColor(Green);
  Write('sec');
  TextColor(LightCyan);
  Write(' Security Station');
  GotoXY(50, 11);
  TextColor(Green);
  Write('asc');
  TextColor(LightCyan);
  Write(' Advanced Security Station');
  GotoXY(50, 12);
  TextColor(Green);
  Write('rep');
  TextColor(LightCyan);
  Write(' Vehicle Repair Bay');
  GotoXY(50, 13);
  TextColor(Green);
  Write('bio');
  TextColor(LightCyan);
  Write(' Biochemistry Lab');
  GotoXY(49, 14);
  TextColor(Green);
  Write('abio');
  TextColor(LightCyan);
  Write(' Advanced Biochemistry Lab');
  GotoXY(50, 15);
  TextColor(Green);
  Write('qua');
  TextColor(LightCyan);
  Write(' Quantum Physics Lab');
  GotoXY(49, 16);
  TextColor(Green);
  Write('aqua');
  TextColor(LightCyan);
  Write(' Advanced Quantum Phys. Lab');
  GotoXY(50, 17);
  TextColor(Green);
  Write('ali');
  TextColor(LightCyan);
  Write(' Alien Containment');
  GotoXY(50, 18);
  TextColor(Green);
  Write('wrk');
  TextColor(LightCyan);
  Write(' Workshop');
  GotoXY(49, 19);
  TextColor(Green);
  Write('awrk');
  TextColor(LightCyan);
  Write(' Advanced Workshop');

  TextColor(LightBlue);

  GotoXY(50, 21);
  Write('Enter - Change tile');
  GotoXY(53, 22);
  Write('F1 - Maximize usable space');
  GotoXY(53, 23);
  Write('F2 - Zero out build times');
  GotoXY(49, 24);
  Write('Delete - Destroy building');

  PaintBase;

  repeat
    ch := ReadKey;
    case ch of
      #13:
        begin
          TextBackground(Black);
          TextColor(LightRed);
          GotoXY(48, TypeToY(base[sy, sx]));
          Write('');
          GotoXY(53, TypeToY(base[sy, sx]));
          Write('');
          ps := TypeToY(base[sy, sx]);
          repeat
            ch := ReadKey;
            if ch = #0 then
            begin
              ch := ReadKey;
              TextColor(Black);
              GotoXY(48, ps);
              Write(' ');
              GotoXY(53, ps);
              Write(' ');
              case ch of
                #80:
                  if ps < 19 then Inc(ps);
                #72:
                  if ps > 2 then Dec(ps);
              end;
              TextColor(LightRed);
              GotoXY(48, ps);
              Write('');
              GotoXY(53, ps);
              Write('');
            end;
          until (ch = #13) or (ch = #27);
          if ch = #13 then
          begin
            ps := YToType(ps);
            b := base[sy, sx];
            base[sy, sx] := ps;
            case ps of
              25, 27, 29, 31, 33:
                begin
                  if sx < 8 then base[sy, sx + 1] := 201;
                  if sy < 8 then base[sy + 1, sx] := 203;
                  if (sy < 8) and (sx < 8) then base[sy + 1, sx + 1] := 202;
                  b := 0;
                end;
            end;
            case b of
              201:
                begin
                  if sx > 1 then base[sy, sx - 1] := 2;
                  if (sy < 8) and (sx > 1) then base[sy + 1, sx - 1] := 2;
                  if sy < 8 then base[sy + 1, sx] := 2;
                end;
              202:
                begin
                  if sy > 1 then base[sy - 1, sx] := 2;
                  if sx > 1 then base[sy, sx - 1] := 2;
                  if (sy > 1) and (sx > 1) then base[sy - 1, sx - 1] := 2;
                end;
              203:
                begin
                  if sx < 8 then base[sy, sx + 1] := 2;
                  if (sx < 8) and (sy > 1) then base[sy - 1, sx + 1] := 2;
                  if sy > 1 then base[sy - 1, sx] := 2;
                end;
              25, 27, 29, 31, 33:
                begin
                  if sx < 8 then base[sy, sx + 1] := 2;
                  if (sy < 8) and (sx < 8) then base[sy + 1, sx + 1] := 2;
                  if sy < 8 then base[sy + 1, sx] := 2;
                end;
            end;
            FixCorridors;
          end
          else
          begin
            GotoXY(48, ps);
            Write(' ');
            GotoXY(53, ps);
            Write(' ');
            ch := 'x';
          end;
          PaintBase;
        end;
    end;
    if ch = #0 then
    begin
      ch := ReadKey;

      TextBackground(Black);
      GotoXY(48, TypeToY(base[sy, sx]));
      Write(' ');
      GotoXY(53, TypeToY(base[sy, sx]));
      Write(' ');

      case ch of
        #79:     {end}
          begin sx := 8; sy := 8; end;
        #71:     {home}
          begin sx := 1; sy := 1; end;
        #80:     {down arrow}
          if sy < 8 then Inc(sy);
        #72:     {up arrow}
          if sy > 1 then Dec(sy);
        #77:     {right arrow}
          if sx < 8 then Inc(sx);
        #75:     {left arrow}
          if sx > 1 then Dec(sx);
        #59:     {F1}
          begin
            for y := 1 to 8 do
              for x := 1 to 8 do
                if base[y, x] = 0 then base[y, x] := 2;
            FixCorridors;
          end;
        #60:     {F2}
          begin
            zeroout := True;
            TextBackground(Black);
            GotoXY(53, 23); ClrEol;
          end;
        #83:     {Del}
          begin
            case base[sy, sx] of
              201:
                begin
                  if sx > 1 then base[sy, sx - 1] := 2;
                  if (sy < 8) and (sx > 1) then base[sy + 1, sx - 1] := 2;
                  if sy < 8 then base[sy + 1, sx] := 2;
                  base[sy, sx] := 2;
                end;
              202:
                begin
                  if sy > 1 then base[sy - 1, sx] := 2;
                  if sx > 1 then base[sy, sx - 1] := 2;
                  if (sy > 1) and (sx > 1) then base[sy - 1, sx - 1] := 2;
                  base[sy, sx] := 2;
                end;
              203:
                begin
                  if sx < 8 then base[sy, sx + 1] := 2;
                  if (sx < 8) and (sy > 1) then base[sy - 1, sx + 1] := 2;
                  if sy > 1 then base[sy - 1, sx] := 2;
                  base[sy, sx] := 2;
                end;
              25, 27, 29, 31, 33:
                begin
                  if sx < 8 then base[sy, sx + 1] := 2;
                  if (sy < 8) and (sx < 8) then base[sy + 1, sx + 1] := 2;
                  if sy < 8 then base[sy + 1, sx] := 2;
                  base[sy, sx] := 2;
                end;
              1..15: base[sy, sx] := 0
              else
              base[sy, sx] := 2;
            end;
            FixCorridors;
          end;
      end;
      PaintBase;
    end;
  until ch = #27;
  FileMode := 2;
  Assign(f, games[sel].FileName);
  Reset(f, 1);
  Seek(f, $1DF6C + (basenum - 1) * 702 + 20);
  BlockWrite(f, base, 8 * 8);
  if zeroout then
  begin
    FillChar(base, 8 * 8, 0);
    BlockWrite(f, base, 8 * 8);
  end;
  Close(f);
  FileMode := 0;
end;

procedure BaseEditMenu(basenum: Word);
var
  t: Text;
  s: String;
  shi: ShortInt;
  osl, code: Word;
  l, offs: Longint;
begin
  Assign(t, 'XC3SGED.INI');
  {$I-}
  Reset(t);
  {$I+}
  if IOResult <> 0 then begin BaseLayout(basenum); Exit; end;
  choices[1] := 'Base layout';
  numchoices := 1;
  while not Eof(t) do
  begin
    Readln(t, s);
    if s[1] = '[' then
    begin
      Delete(s, 1, 1);
      Delete(s, Length(s), 1);
      Inc(numchoices);
      choices[numchoices] := s;
    end;
  end;
  Close(t);

  sel2 := 1;
  repeat
    TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
    TextColor(LightCyan);
    Writeln(' Base editing'#10);
    shi := SelectFromChoices(False);
    osl := sel2;
    if shi = 0 then
    begin
      case sel2 of
        1: BaseLayout(basenum);
        else
          begin
            TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
            TextColor(White);
            Writeln(' ' + choices[sel2] + #10);
            sel3 := 1;
            Assign(f, games[sel].FileName);
            Reset(f, 1);
            l := $1DF6C + (basenum - 1) * 702;
            Reset(t);
            while not Eof(t) do
            begin
              Readln(t, s);
              if s[1] = '[' then
              begin
                Delete(s, 1, 1);
                Delete(s, Length(s), 1);
                if choices[sel2] = s then Break;
              end;
            end;
            numvaluelist := 0;
            while not Eof(t) do
            begin
              Readln(t, s);
              if s[1] = '[' then Break;
              if (s <> '') and (s[1] <> ';') then
              begin
                Inc(numvaluelist);
                valuelist[numvaluelist].name := Copy(s, 1, Pos('=', s) - 1);
                Delete(s, 1, Pos('=', s));
                Val(s, offs, code);
                Seek(f, l + offs);
                BlockRead(f, code, 2);
                valuelist[numvaluelist].value := code;
              end;
            end;
            Close(t);
            Close(f);
            EditList(6, True, False, False);
            Reset(t);
            FileMode := 2;
            Reset(f, 1);
            l := $1DF6C + (basenum - 1) * 702;
            while not Eof(t) do
            begin
              Readln(t, s);
              if s[1] = '[' then
              begin
                Delete(s, 1, 1);
                Delete(s, Length(s), 1);
                if choices[sel2] = s then Break;
              end;
            end;
            numvaluelist := 0;
            while not Eof(t) do
            begin
              Readln(t, s);
              if s[1] = '[' then Break;
              if (s <> '') and (s[1] <> ';') then
              begin
                Inc(numvaluelist);
                Delete(s, 1, Pos('=', s));
                Val(s, offs, code);
                Seek(f, l + offs);
                BlockWrite(f, valuelist[numvaluelist].value, 2);
              end;
            end;
            Close(f);
            Close(t);
            FileMode := 0;
          end;
      end;
    end;
    sel2 := osl;
  until shi = -1;
end;

{ Shows a menu to allow the user to select which base he wants to edit }
procedure EditBase;
var
  shi: Shortint;
  osl: Word;
begin
  Assign(f, games[sel].FileName);
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Cannot open file ' + games[sel].FileName + '.', False);

  l := $1DF6C;
  numchoices := 0;
  FillChar(NullStr, SizeOf(NullStr), 0);
  repeat
    Seek(f, l);
    BlockRead(f, NullStr, 20);
    if NullStr[0] <> #0 then
    begin
      Inc(numchoices);
      choices[numchoices] := NullTerminatedToPasString(NullStr);
    end;
    Inc(l, 702);
  until NullStr[0] = #0;
  Close(f);

  if numchoices > 1 then   { if there is only one base, we don't need to ask }
  begin
    sel2 := 1;
    repeat
      Reset(f, 1);
      l := $1DF6C;
      numchoices := 0;
      FillChar(NullStr, SizeOf(NullStr), 0);
      repeat
        Seek(f, l);
        BlockRead(f, NullStr, 20);
        if NullStr[0] <> #0 then
        begin
          Inc(numchoices);
          choices[numchoices] := NullTerminatedToPasString(NullStr);
        end;
        Inc(l, 702);
      until NullStr[0] = #0;
      Close(f);
      TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
      TextColor(LightCyan);
      Writeln(' Which base would you like to edit?'#10);
      shi := SelectFromChoices(False);
      osl := sel2;
      if shi = 0 then
        BaseEditMenu(sel2);
      sel2 := osl;
    until shi = -1;
  end
  else
    BaseEditMenu(1);
end;

procedure EditVehicles;
var
  shi, shi2: Shortint;
  osl: Word;
  l: Longint;
  bf: Pointer;
  x: file;
begin
  Assign(f, games[sel].FileName);
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Cannot open file ' + games[sel].FileName + '.', False);

  sel2 := 1;
  repeat
    Reset(f, 1);
    l := $8174;
    numchoices := 0;
    FillChar(NullStr, SizeOf(NullStr), 0);
    repeat
      Seek(f, l);
      BlockRead(f, NullStr, 40);
      if NullStr[0] <> #0 then
      begin
        Inc(numchoices);
        choices[numchoices] := NullTerminatedToPasString(NullStr);
      end;
      Inc(l, 630);
    until NullStr[0] = #0;
    Close(f);

    TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
    TextColor(LightCyan);
    Writeln(' Before modifying a vehicle''s type, I stongly suggest you ');
    Writeln(' to remove all equipment on it, or the game may even crash.'#10);
    shi := SelectFromChoices(False);
    osl := sel2;
    if shi = 0 then
    begin
      choices[1] := 'Police Hovercar';
      choices[2] := 'Airtaxi';
      choices[3] := 'Rescue Transport';
      choices[4] := 'Construction Vehicle';
      choices[5] := 'Airtrans';
      choices[6] := 'Space Liner';
      choices[7] := 'Phoenix Hovercar';
      choices[8] := 'Hoverbike';
      choices[9] := 'Valkyrie Interceptor';
      choices[10] := 'Hawk Air Warrior';
      choices[11] := 'Dimension Probe';
      choices[12] := 'Biotrans';
      choices[13] := 'Explorer';
      choices[14] := 'Retaliator';
      choices[15] := 'Annihilator';
      choices[16] := 'Autotaxi';
      choices[17] := 'Autotrans';
      choices[18] := 'Police Car';
      choices[19] := 'Civilian Car';
      choices[20] := 'Stormdog';
      choices[21] := 'Wolfhound APC';
      choices[22] := 'Blazer Turbo Bike';
      choices[23] := 'Griffon AFV';
      numchoices := 23;
      l := $8174 + (sel2 - 1) * 630;

      Reset(f, 1);
      Seek(f, l + 390);
      BlockRead(f, b, 1);
      sel2 := b;
      Close(f);
      TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
      TextColor(LightCyan);
      Writeln(b);
      Writeln(' Vehicle type'#10);
      shi2 := SelectFromChoices(False);
      if shi2 = 0 then
      begin
        FileMode := 2;
        Reset(f, 1);
{        b := sel2;
        Seek(f, l + 390);
        BlockWrite(f, b, 1);}
{        Seek(f, l);
        GetMem(bf, 1000);
        BlockRead(f, bf^, 630);
        Assign(x, 'temp.tmp');
        Rewrite(x, 1);
        BlockWrite(x, bf^, 630);
        Close(x);
        FreeMem(bf, 1000);}
        Close(f);
      end;

    end;
    sel2 := osl;
  until shi = -1;
end;

procedure CompleteUFOpaedia;
var
  buf: Pointer;
begin
  choices[1] := 'Only items which are in the final release';
  choices[2] := 'Everything, including obsolete items';
  numchoices := 2;
  sel2 := 1;
  TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
  TextColor(LightCyan);
  Writeln(' This will NOT enable you to manufacture everything, this will');
  Writeln(' not make your Research screen show ''Complete'' for every project,');
  Writeln(' and this will not allow you to use unresearched Alien Artifacts.'#10);
  Writeln(' This will only enable you to view every page of UFOpaedia.');
  Writeln(' If you don''t want to do it, press Esc now to return to the previous menu.');
  Writeln(' Otherwise you have to decide whether you want only the pages');
  Writeln(' which are in the final version of X-COM 3, or you want to enable');
  Writeln(' really everything, including for example the Tracker Gun, One Way To Win,');
  Writeln(' Advanced Alien Containment, etc.'#10);
  if SelectFromChoices(False) = 0 then
  begin
    FileMode := 2;
    Assign(f, games[sel].FileName);
    Reset(f, 1);
    Seek(f, $6A5CB);
    if sel2 = 2 then
    begin
      GetMem(buf, SizeOf(UFOpaedia));
      FillChar(buf^, SizeOf(UFOpaedia), 1);
      BlockWrite(f, buf^, SizeOf(UFOpaedia));
      FreeMem(buf, SizeOf(UFOpaedia));
      Seek(f, $6A5E2);      { disable Brainsucker Pod autopsy, because }
      b := 0;               { that would crash the game }
      BlockWrite(f, b, 1);
    end
    else
      BlockWrite(f, UFOpaedia, SizeOf(UFOpaedia));
    Close(f);
    FileMode := 0;
  end;
end;

{ Changing money... The simplest and most popular cheat of the world. :) }
procedure ChangeMoney;
var
  cash: Longint;
begin
  FileMode := 2;
  Assign(f, games[sel].FileName);
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Cannot open file ' + games[sel].FileName + '.', False);
  Seek(f, 212288);
  BlockRead(f, cash, 4);
  TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
  TextColor(LightGray);
  Writeln(' So you need more cash, eh? Okay, just type it in below.');
  Writeln(' (You cannot have more than $2147483647, but who cares.)'#10);
  TextColor(LightCyan);
  Write(' Money: ');
  TextBackground(Blue);
  TextColor(White);
  Write('$');
  cash := InputNumericValue(cash, -2147483647, 2147483647, 11);
  Seek(f, 212288);
  BlockWrite(f, cash, 4);
  Close(f);
  FileMode := 0;
end;

var
  ch: Char;

begin
  CurrentFile := '';
  sel := 0;
  TextBackground(Black); TextColor(LightGray);
  ClrScr;
  WriteHeader;

{
  repeat
    ch := ReadKey;
    Writeln(ord(ch));
  until ch = #27;
  Halt;}

  { Try opening xcomapoc.exe, to check if we are in the right directory. }
  FileMode := 0;
  Assign(f, 'xcomapoc.exe');
  {$I-}
  Reset(f, 1);
  {$I+}
  if IOResult <> 0 then
    ErrorMessage('Please run this program from your X-COM: '+
                 'Apocalypse directory.', False);
  Close(f);

  LoadSaveGameDirectory;

  { Hide the cursor }
  asm
    mov ah, 1
    mov cx, 2000h
    int 10h
  end;

  while not(MainMenu = -1) do
  begin
    if games[sel].isTactical then
    begin
      EditPeople;
    end
    else
    begin
      sel2 := 1;
      repeat
        CurrentFile := games[sel].FileName;
        Delete(CurrentFile, 1, Length(SaveGame_Directory));
        TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
        WriteMainMenuLine(sel, False, True);
        Writeln;
        choices[1] := 'Change money';
        choices[2] := 'Edit agents';
        choices[3] := 'Base editor';
{        choices[4] := 'Edit vehicles';}
        choices[4] := 'Enable whole UFOpaedia';
        numchoices := 4;
        si := SelectFromChoices(False);
        osel2 := sel2;
        if si = 0 then
        begin
          case sel2 of
            1: ChangeMoney;
            2: EditPeople;
            3: EditBase;
{            4: EditVehicles;}
            4: CompleteUFOpaedia;
          end;
          si := 0;
        end;
        sel2 := osel2;
      until si = -1;
      CurrentFile := '';
    end;
    TextBackground(Black); TextColor(LightGray); ClrScr; WriteHeader;
  end;
  Quit;
end.

